var state = {
    L: false,
    Mid: false,
    R: false
};

var isGestureEnded = false;

function Effect() {
    var self = this;

    this.meshes = [
        { file: "bulb.bsm2", anims: [
            { a: "static", t: 0 },
        ] },
        { file: "light_L.bsm2", anims: [
            { a: "static", t: 0 },
        ] },
        { file: "light_Mid.bsm2", anims: [
            { a: "static", t: 0 },
        ] },
        { file: "light_R.bsm2", anims: [
            { a: "static", t: 0 },
        ] },
    ];

    this.play = function() {
        var now = (new Date()).getTime();
        for(var i = 0; i < self.meshes.length; i++) {
            if(now > self.meshes[i].endTime) {
                self.meshes[i].animIdx = (self.meshes[i].animIdx + 1)%self.meshes[i].anims.length;
                Api.meshfxMsg("animOnce", i, 0, self.meshes[i].anims[self.meshes[i].animIdx].a);
                self.meshes[i].endTime = now + self.meshes[i].anims[self.meshes[i].animIdx].t;
            }
        }

        // if(isMouthOpen(world.landmarks, world.latents)) {
        //  Api.hideHint();
        // }
    };

    this.init = function() {
        Api.meshfxMsg("spawn", 4, 0, "!glfx_FACE");

        Api.meshfxMsg("spawn", 0, 0, "bulb.bsm2");
        // Api.meshfxMsg("animOnce", 0, 0, "static");

        Api.meshfxMsg("shaderVec4", 0, 0, "1. 0. 0. 0.");

        // Api.meshfxMsg("spawn", 1, 0, "light_L.bsm2");
        // Api.meshfxMsg("animOnce", 1, 0, "static");

        // Api.meshfxMsg("spawn", 2, 0, "light_Mid.bsm2");
        // Api.meshfxMsg("animOnce", 2, 0, "static");

        // Api.meshfxMsg("spawn", 3, 0, "light_R.bsm2");
        // Api.meshfxMsg("animOnce", 3, 0, "static");

        Api.showRecordButton();
    };

    this.restart = function() {
        Api.meshfxReset();
        self.init();
    };

    this.faceActions = [];
    this.noFaceActions = [];

    this.videoRecordStartActions = [];
    this.videoRecordFinishActions = [];
    this.videoRecordDiscardActions = [this.restart];
}

configure(new Effect());

function makeString(){
	var args = [];
	for (var i = 0; i < arguments.length; i++) {
	  args[i] = arguments[i];
	}
	return args.join(",");
}

function onTouchesBegan(){
};

function onScaleGesture(scale){
	Api.meshfxMsg("tex", 0, 0, "scale.png");
	Api.print("JS SCALE: " + scale);
	Api.meshfxMsg("shaderVec4", 0, 0, makeString(scale));
}

function onRotationGesture(angle){
	Api.meshfxMsg("tex", 0, 0, "rotation.png");
	Api.print("JS ANGLE: " + angle);
	Api.meshfxMsg("shaderVec4", 0, 1, makeString(angle));
}

function onSwipeGesture(direction_x, direction_y){
    if(!state.Mid && direction_y == 1){
        Api.meshfxMsg("spawn", 2, 0, "light_Mid.bsm2");
        state.Mid = true;
    } else if( state.Mid && (!state.L || !state.R) && direction_y == -1){
           Api.meshfxMsg("del", 2);
            state.Mid = false;
    } else if ((!state.L || !state.R) && direction_y == 1) {
        Api.meshfxMsg("spawn", 1, 0, "light_L.bsm2");
        state.L = true;
        Api.meshfxMsg("spawn", 3, 0, "light_R.bsm2");
        state.R = true;
    }
    else if ((state.L || state.R) && direction_y == -1) {
        Api.meshfxMsg("del", 1);
        Api.meshfxMsg("del", 3);
        state.L = false;
        state.R = false;
    } else if (!state.L && !state.Mid && direction_x == 1) {
        Api.meshfxMsg("spawn", 1, 0, "light_L.bsm2");
        state.L = true;
    }
    else if (state.L && !state.Mid && !state.R && direction_x == -1) {
        Api.meshfxMsg("del", 1);
        state.L = false;
    }
    else if (!state.Mid && !state.R && direction_x == 1) {
        Api.meshfxMsg("spawn", 2, 0, "light_Mid.bsm2");
        state.Mid = true;
    } 
    else if (state.Mid && !state.R && direction_x == -1) {
        Api.meshfxMsg("del", 2);
        state.Mid = false;
    } 
    else if (!state.R && direction_x == 1) {
        Api.meshfxMsg("spawn", 3, 0, "light_R.bsm2");
        state.R = true;
    }
    else if (state.R && direction_x == -1) {
        Api.meshfxMsg("del", 3);
        state.R = false;
    }
     else {
        turnOffTheLights();
    }
    Api.print("SWIPE JS direction_x: " + direction_x);
	Api.print("SWIPE JS direction_y: " + direction_y);
}

function onDoubleTapGesture(touch_position_x, touch_position_y){
	if(!state.Mid){
		Api.meshfxMsg("spawn", 2, 0, "light_Mid.bsm2");
		state.Mid = true;
	} else if (!state.L){
		Api.meshfxMsg("spawn", 1, 0, "light_L.bsm2");
		state.L = true;
	} else if (!state.R){
        Api.meshfxMsg("spawn", 3, 0, "light_R.bsm2");
        state.R = true;
    } else {
        turnOffTheLights();
    }
    Api.print("DOUBLE_TAP JS touch_position_x: " + touch_position_x);
    Api.print("DOUBLE TAP JS touch_position_y: " + touch_position_y);
}

function onLongTapGesture(touch_position_x, touch_position_y){

    if (!isGestureEnded){	if(state.Mid || state.L || state.R) {
        turnOffTheLights();
    } else {
        turnOnTheLights();
    }
    Api.print("LONG_TAP JS touch_position_x: " + touch_position_x);
    Api.print("LONG TAP JS touch_position_y: " + touch_position_y);}
    onGestureEnded();
}

function onGestureEnded(){
	isGestureEnded = true;
	timeOut(500, function(){
		isGestureEnded = false;
	})
}

function turnOffTheLights(){
    Api.meshfxMsg("del", 1);
    Api.meshfxMsg("del", 2);
    Api.meshfxMsg("del", 3);
    state.Mid = false;
    state.L = false;
    state.R = false;
}

function turnOnTheLights(){
    Api.meshfxMsg("spawn", 2, 0, "light_Mid.bsm2");
    Api.meshfxMsg("spawn", 1, 0, "light_L.bsm2");
    Api.meshfxMsg("spawn", 3, 0, "light_R.bsm2");
    state.Mid = true;
    state.L = true;
    state.R = true;
}

function timeOut(delay, callback) {
    var timer = new Date().getTime();

    effect.faceActions.push(removeAfterTimeOut);
    effect.noFaceActions.push(removeAfterTimeOut);

    function removeAfterTimeOut() {
        var now = new Date().getTime();

        if (now >= timer + delay) {
            var idx = effect.faceActions.indexOf(removeAfterTimeOut);
            effect.faceActions.splice(idx, 1);
            idx = effect.noFaceActions.indexOf(removeAfterTimeOut);
            effect.noFaceActions.splice(idx, 1);
            callback();
        }
    }
}